/*******************************************************************************
 * Copyright (c) 2011, 2012 IBM Corporation and others.
 *
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *  
 *  The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 *  and the Eclipse Distribution License is available at
 *  http://www.eclipse.org/org/documents/edl-v10.php.
 *  
 *  Contributors:
 *  
 *	   Sam Padgett	       - initial API and implementation
 *     Michael Fiedler     - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.assume.adaptors.pror;

import com.google.common.base.Strings;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.nio.file.Path;
import java.nio.file.Paths;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.ServletContextEvent;
import java.util.List;

import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.tools.store.StoreFactory;
import se.kth.md.aide.oslc.ccm.VersionServiceConfiguration;
import se.kth.md.aide.repository.api.Revision;
import se.kth.md.aide.repository.jgit.GitRepository;
import se.kth.md.assume.adaptors.pror.servlet.ServiceProviderCatalogSingleton;
import se.kth.md.assume.adaptors.pror.resources.Requirement;
import se.kth.md.assume.adaptors.pror.resources.RequirementCollection;

// Start of user code imports
import com.google.common.collect.ImmutableList;
import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.NoSuchElementException;
import java.util.Optional;
import java.util.concurrent.ExecutionException;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import javax.servlet.ServletContext;
import org.eclipse.lyo.tools.store.ModelUnmarshallingException;
import org.eclipse.lyo.tools.store.Store;
import org.eclipse.lyo.tools.store.StoreAccessException;
import org.eclipse.lyo.tools.store.update.StoreUpdateManager;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import se.kth.md.aide.diff.RepositoryResourceExtractor;
import se.kth.md.aide.repository.api.Repository;
import se.kth.md.aide.repository.api.RepositoryAccessException;
import se.kth.md.aide.repository.api.RevisionAbstractObject;
import se.kth.md.assume.adaptors.pror.repository.RequirementExtractor;
import se.kth.md.assume.adaptors.pror.servlet.KeyProvider;
import se.kth.md.assume.adaptors.pror.servlet.ServletListener;
import se.kth.md.assume.repository.update.RepositoryChangeProviderImpl;
import se.kth.md.assume.repository.update.RepositoryStoreHelper;
import se.kth.md.assume.repository.update.RevisionOSLCMessage;
import se.kth.md.assume.repository.update.handlers.ResourceVersionHandler;
import se.kth.md.assume.repository.update.handlers.RevisionHandler;
import se.kth.md.assume.repository.update.handlers.TrsDiffHandler;

// End of user code

// Start of user code pre_class_code
// End of user code

public class ProRManager {

    // Start of user code class_attributes
    private static final Logger log = LoggerFactory.getLogger(ProRManager.class);
    private static RepositoryStoreHelper<Requirement> requirements;
    private static Store store;
    private static Repository repository;
    private static RepositoryResourceExtractor extractor;
    private static ProrRevisionKeyProviderImpl keyProvider; // TODO /Andrew 21.03.17: generalize
    private static final String PACKAGE_NAME = "se.kth.md.assume.adaptors.pror";
    // End of user code

    // Start of user code class_methods
    public static Store getStore() {
        return store;
    }

    private static String currentRevisionId() throws ExecutionException {
        return requirements.getCurrentRevision().getId();
    }

    private static List<Requirement> fetchRequirements(String serviceProviderId, String versionId)
            throws IOException, StoreAccessException, ExecutionException, ModelUnmarshallingException {
        List<Requirement> requirementList = requirements.getResources(serviceProviderId, findVersion(versionId));
        if (requirementList != null) {
            List<Requirement> resources = new ArrayList<>(requirementList);
            log.trace("fetchRequirements served '{}' resources via the repository manager", serviceProviderId);
            return resources;
        } else {
            log.warn("fetchRequirements served '{}' resources from dummy source", serviceProviderId);
            return new ArrayList<>();
        }
    }

    private static Revision findVersion(String versionId) {
        return repository.getRevisions().stream()
                .filter(revision -> revision.getId().equals(versionId)).findAny().orElse(null);
    }

    private static ServiceProviderInfo spInfoFromRevObject(RevisionAbstractObject revisionedObject) {
        ServiceProviderInfo info = new ServiceProviderInfo();
        String filePath = revisionedObject.getPath();
        info.name = filePath;
        info.serviceProviderId = Paths.get(filePath).getFileName().toString();
        return info;
    }

    private static <T> List<T> slicePaging(List<T> resources, int page, int limit) {
        if (limit <= 0) {
            return resources;
        }
        int fromIndex = page * limit;
        // override due to a bug in service that determines paging flag,
        // it removes the last element if there are more than 'limit' records
        int limitIndex = fromIndex + limit + 1; // TODO: 2016-12-26 remove +1 workaround
        int toIndex = Math.min(limitIndex, resources.size());
        log.trace("Creating a slice [{},{}] on a list of {} elements", fromIndex, toIndex, resources.size());
        // because service calls .remove() method that is not defined on some immutable implementations
        // TODO: 2016-12-25 fix in the generator to call subList(0, size-1)
        return new ArrayList<>(resources.subList(fromIndex, toIndex));
    }

    private static Optional<String> queryVersionParam(HttpServletRequest httpServletRequest) {
        if (httpServletRequest.getQueryString() != null) {
            String[] queryParams = httpServletRequest.getQueryString().split("&");
            try {
                for (String pair : queryParams) {
                    final int idx = pair.indexOf("=");
                    final String key = idx > 0 ? URLDecoder.decode(pair.substring(0, idx), "UTF-8") : pair;
                    final String value = idx > 0 && pair.length() > idx + 1 ?
                            URLDecoder.decode(pair.substring(idx + 1), "UTF-8") :
                            null;
                    if ("oslc_config:versionId".equals(key) && !Strings.isNullOrEmpty(value)) {
                        log.info("Resource version '{}' specified", value);
                        return Optional.of(value);
                    }
                }
            } catch (UnsupportedEncodingException e) {
                log.error("Error decoding the query parameter string", e);
            }
        }
        return Optional.empty();
    }

    private static Repository buildRepository(ServletContext servletContext) throws IOException {
        String repositoryDirParam = servletContext.getInitParameter("se.kth.md.assume.adaptors.pror.servlet.repository.dir");
        Path repositoryDir = Paths.get(repositoryDirParam);
        log.info("ProR adaptor Git directory: {}", repositoryDir);
        return new GitRepository(repositoryDir.toString());  // TODO: 2017-01-09 accept Path object
    }

    private static Store buildStore(ServletContext servletContext) throws IOException {
        String sparqlQuery = servletContext.getInitParameter(PACKAGE_NAME + ".servlet.store.query");
        String sparqlUpdate = servletContext.getInitParameter(PACKAGE_NAME + ".servlet.store.update");
        return StoreFactory.sparql(sparqlQuery, sparqlUpdate);
    }
    // End of user code

    public static void contextInitializeServletListener(final ServletContextEvent servletContextEvent)
    {
        
        // Start of user code contextInitializeServletListener
        KeyProvider provider = ServiceProviderCatalogSingleton::constructServiceProviderURI;
        try {
            ServletContext servletContext = servletContextEvent.getServletContext();
            log.info("ProRManager.contextInitializeServletListener() was called");
            if (requirements == null) {
                keyProvider = new ProrRevisionKeyProviderImpl();
                extractor = new RequirementExtractor();

                store = buildStore(servletContext);
                store.removeAll().execute();

                repository = buildRepository(servletContext);

                requirements = new RepositoryStoreHelper<>(repository, store, keyProvider,
                        Requirement.class);

                RepositoryChangeProviderImpl changeProvider = new RepositoryChangeProviderImpl(
                        repository, ImmutableList.of(extractor), keyProvider);

                StoreUpdateManager<RevisionOSLCMessage> updateManager = new StoreUpdateManager<>(
                        store, changeProvider);

                updateManager.addHandler(
                        new TrsDiffHandler(URI.create(ProRConstants.TRS_GRAPH_NAME)));

                updateManager.addHandler(new RevisionHandler<>(keyProvider, repository));

                String servicesBase = ServletListener.getServicesBase();
                VersionServiceConfiguration.keyProvider = keyProvider;
                VersionServiceConfiguration.servicesBase = servicesBase;
                VersionServiceConfiguration.store = store;
                ServiceProvider[] serviceProviders = ServiceProviderCatalogSingleton
                        .getServiceProviders(
                        null);
                updateManager.addHandler(
                        new ResourceVersionHandler<>(serviceProviders, repository, servicesBase));

                updateManager.poll(null, 30);  // TODO: 2016-12-29 check
            }
        } catch (IOException e) {
            log.error("Error while building the Repository object", e);
        }
        // End of user code
    }

    public static void contextDestroyServletListener(ServletContextEvent servletContextEvent) 
    {
        
        // Start of user code contextDestroyed
        // End of user code
    }

    public static ServiceProviderInfo[] getServiceProviderInfos(HttpServletRequest httpServletRequest)
    {
        ServiceProviderInfo[] serviceProviderInfos = {};
        
        // Start of user code "ServiceProviderInfo[] getServiceProviderInfos(...)"
        List<RevisionAbstractObject> revisionedObjects = null;
        try {
            // TODO /Andrew 13.03.17: implement empty filter
            revisionedObjects = repository.getRevisionObjects(requirements.getCurrentRevision(),
              extractor.getFilter(repository.getFilterFactory()));
            List<ServiceProviderInfo> providerInfos = revisionedObjects.stream()
              .map(ProRManager::spInfoFromRevObject)
              .collect(Collectors.toList());
            serviceProviderInfos = providerInfos.toArray(new ServiceProviderInfo[0]);
        } catch (RepositoryAccessException e) {
            e.printStackTrace();
        }
        // End of user code
        return serviceProviderInfos;
    }

    public static List<Requirement> queryRequirements(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<Requirement> resources = null;
        
        // Start of user code queryRequirements
        try {
            resources = fetchRequirements(serviceProviderId, currentRevisionId());
        } catch (IOException | StoreAccessException | ModelUnmarshallingException | ExecutionException e) {
            log.error(String.valueOf(e));
        }
        resources = slicePaging(resources, page, limit);
        // End of user code
        return resources;
    }
    public static List<RequirementCollection> queryRequirementCollections(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<RequirementCollection> resources = null;
        
        // Start of user code queryRequirementCollections
        resources = new ArrayList<>();
        // End of user code
        return resources;
    }
    public static List<Requirement> RequirementSelector(HttpServletRequest httpServletRequest, final String serviceProviderId, String terms)   
    {
        List<Requirement> resources = null;
        
        // Start of user code RequirementSelector
        try {
            resources = fetchRequirements(serviceProviderId, currentRevisionId());
        } catch (IOException | StoreAccessException | ModelUnmarshallingException | ExecutionException e) {
            log.warn("Exception while fetching requirements for the DUI selector", e);
        }
        // End of user code
        return resources;
    }


    public static Requirement getRequirement(HttpServletRequest httpServletRequest, final String serviceProviderId, final String requirementId)
    {
        Requirement aResource = null;
        
        // Start of user code getRequirement
        Optional<String> version = queryVersionParam(httpServletRequest);
        try {
            List<Requirement> requirementList;
            if (!version.isPresent()) {
                requirementList = fetchRequirements(serviceProviderId, currentRevisionId());
            } else {
                requirementList = fetchRequirements(serviceProviderId, version.get());
            }
            Stream<Requirement> requirementStream = requirementList.stream();
            Stream<Requirement> filteredStream = requirementStream.filter(r -> r.getIdentifier().equals(requirementId));
            aResource = filteredStream.findFirst().get();
        } catch (IOException | StoreAccessException | ModelUnmarshallingException | ExecutionException | NoSuchElementException | NullPointerException e) {
            log.error(String.valueOf(e));
        }
        // End of user code
        return aResource;
    }
    public static RequirementCollection getRequirementCollection(HttpServletRequest httpServletRequest, final String serviceProviderId, final String requirementCollectionId)
    {
        RequirementCollection aResource = null;
        
        // Start of user code getRequirementCollection
        // End of user code
        return aResource;
    }

    public static String getETagFromRequirementCollection(final RequirementCollection aResource)
    {
        String eTag = null;
        // Start of user code getETagFromRequirementCollection
        eTag = aResource.getIdentifier();
        // End of user code
        return eTag;
    }
    public static String getETagFromRequirement(final Requirement aResource)
    {
        String eTag = null;
        // Start of user code getETagFromRequirement
        eTag = aResource.getIdentifier();
        // End of user code
        return eTag;
    }
}
